Clazz.declarePackage ("jalview.io");
Clazz.load (["jalview.io.AlignFile", "java.util.Vector"], "jalview.io.PIRFile", ["jalview.io.ModellerDescription", "jalview.util.Comparison", "java.lang.StringBuffer"], function () {
c$ = Clazz.decorateAsClass (function () {
this.words = null;
Clazz.instantialize (this, arguments);
}, jalview.io, "PIRFile", jalview.io.AlignFile);
Clazz.prepareFields (c$, function () {
this.words =  new java.util.Vector ();
});
Clazz.makeConstructor (c$, 
function () {
Clazz.superConstructor (this, jalview.io.PIRFile, []);
});
Clazz.overrideMethod (c$, "parse", 
function () {
var sequence;
var line = null;
var md;
while ((line = this.nextLine ()) != null) {
if (line.length == 0) {
continue;
}if (line.indexOf ("C;") == 0 || line.indexOf ("#") == 0) {
continue;
}var newSeq = this.parseId (line.substring (line.indexOf (";") + 1));
sequence =  new StringBuffer ();
newSeq.setDescription (this.nextLine ());
var starFound = false;
while (!starFound) {
line = this.nextLine ();
sequence.append (line);
if (line == null) {
break;
}if (line.indexOf ("*") > -1) {
starFound = true;
}}
if (sequence.length () > 0) {
sequence.setLength (sequence.length () - 1);
newSeq.setSequence (sequence.toString ());
this.seqs.addElement (newSeq);
md =  new jalview.io.ModellerDescription (newSeq.getDescription ());
md.updateSequenceI (newSeq);
}}
});
Clazz.defineMethod (c$, "print", 
function () {
return this.print (this.getSeqsAsArray ());
});
Clazz.defineMethod (c$, "print", 
function (s) {
var is_NA = jalview.util.Comparison.isNucleotide (s);
var len = 72;
var out =  new StringBuffer ();
var i = 0;
var md;
while ((i < s.length) && (s[i] != null)) {
var seq = s[i].getSequenceAsString ();
seq = seq + "*";
if (is_NA) {
out.append (">N1;" + s[i].getName ());
out.append (this.newline);
if (s[i].getDescription () == null) {
out.append (s[i].getName () + " " + (s[i].getEnd () - s[i].getStart () + 1));
out.append (is_NA ? " bases" : " residues");
out.append (this.newline);
} else {
out.append (s[i].getDescription ());
out.append (this.newline);
}} else {
if (jalview.io.PIRFile.useModellerOutput) {
out.append (">P1;" + s[i].getName ());
out.append (this.newline);
md =  new jalview.io.ModellerDescription (s[i]);
out.append (md.getDescriptionLine ());
out.append (this.newline);
} else {
out.append (">P1;" + this.printId (s[i]));
out.append (this.newline);
if (s[i].getDescription () != null) {
out.append (s[i].getDescription ());
out.append (this.newline);
} else {
out.append (s[i].getName () + " " + (s[i].getEnd () - s[i].getStart () + 1) + " residues");
out.append (this.newline);
}}}var nochunks = (Clazz.doubleToInt (seq.length / len)) + 1;
for (var j = 0; j < nochunks; j++) {
var start = j * len;
var end = start + len;
if (end < seq.length) {
out.append (seq.substring (start, end));
out.append (this.newline);
} else if (start < seq.length) {
out.append (seq.substring (start));
out.append (this.newline);
}}
i++;
}
return out.toString ();
}, "~A");
Clazz.defineStatics (c$,
"useModellerOutput", false);
});
